/**
	First implementatios of Turtle Graphics
	turtle.cpp v. 0.0

	Fraga 12/09/2000

======================================================

    Modificaciones para la TAREA 07 por:
    Jorge J. Fernndez Arniz
    22/10/2000
    avion.cpp v.0.8.4

    Se crea un avin en pantalla a partir de 14 puntos que definen
    la figura bsica. En funcin del comando tecleado por el
    usuario, se aplica la transformacin necesaria. Las posibles
    transformaciones, son:
    		Rotacion        R
    		Escalamiento    S
    		
    La figura es dibujada usando una polilnea (drawPolyLine())
    Las rotaciones son con respecto al centro de masa del avin,
    que en este caso coinciden con el origen del sistema de
    coordenadas.

    El cdigo de teclas, es el siguiente:
    ------------------------------------------------
    transformacin   -   +    descripcin
    ------------------------------------------------
                   U   I   ROTACIN SOBRE X
        R          J   K   ROTACIN SOBRE Y
                   M   ;   ROTACION SOBRE Z
        S          +   -   ESCALAMIENTO
    ------------------------------------------------
======================================================
Un cubo rotando sobre su diagonal principal de
(0,0,0) a (1,1,1). Se dibuja un cubo unitario, la
diagonal principal en color rojo y se dibuja
en proyeccin caballera a 30 grados. 

Fraga 07/11/2000	
=====================================================
**/
#include <qpainter.h>
#include <qpen.h>				// permite manejar el color de la pluma
#include "cubo.h"

// JFA:
//    Con estas definiciones, se mapean puntos en las coordenadas
//    del plano cartesiano a las coordenadas de pantalla, asumiendo
//    que el origen de las coordenadas est en el centro del lienzo
//    sobre el que se realiza el trazo.
#define Tx(x)  (xini + (x))
#define Ty(y)  (yini - (y))

// JFA: redondeo propuesto...
#define Round(x) ((x)<0)?int((x)-0.4999999):int((x)+0.5)


#include <values.h>
#include <math.h>
#include <stdio.h>
#include <qpointarray.h>
#include <qpoint.h>
#include <iostream.h>

#include <stdlib.h>      // para aleatorios...
#include <time.h>
#include <unistd.h>

Cubo::Cubo( QWidget *parent, const char *name )
        : QWidget( parent, name )
{
	// Se llenan el arreglo de puntos	
	puntos();

	// Se escale para visualizarlo sobre la pantalla
	cambiaEscala3D(120.0);
	puntosAenteros( );

	// cambiaRota3D( -45, 'z');
	// cambiaRota3D(  35.26, 'y');
	
	setPalette( QPalette( QColor( 250, 250, 200) ) );
	setMouseTracking( TRUE );

	xact = yact = 0;
	xact_d = yact_d = 0.0;
	ang = 90.0; penst=1;
	pen_color = black;

	timer = new QTimer( this, "mytimer" );
	connect ( timer, SIGNAL(timeout()), this, SLOT(timerDone()) );
}


void Cubo::timerDone( )
{
	// cambiaRota3D(  10, 'z');

	cambiaRota3D( -45, 'z');
	cambiaRota3D(  35.26, 'y');
	cambiaRota3D(  10, 'x');
	cambiaRota3D(  -35.26, 'y');
	cambiaRota3D(  45, 'z');

	puntosAenteros( );
	repaint( );

}
void Cubo::puntosAenteros( )
{
	// Para una proyeccin Cabinet a 30 grados
	double lsen30 = 0.5*sin(30*M_PI/180);
	double lcos30 = 0.5*cos(30*M_PI/180);
	// double lsen30 = sin(30*M_PI/180);
	// double lcos30 = cos(30*M_PI/180);

	// Cambiamos a una proyeccin Cabinet a 30 grados
	for(int i=0; i<Npuntos; i++ ) {
		double xp = fpuntos3D[i].fx - lcos30*fpuntos3D[i].fz;
		double yp = fpuntos3D[i].fy - lsen30*fpuntos3D[i].fz;
		// Para uno proyeccin paralela ortogrfica
		// double xp = fpuntos3D[i].fx;
		// double yp = fpuntos3D[i].fy;
		ipuntos3D[i].x = Round( xp ); 
		ipuntos3D[i].y = Round( yp ); 
	}
}

void Cubo::mouseMoveEvent( QMouseEvent * e )
{
	QPoint c = e->pos( );

	xmouse = c.x( );
	ymouse = c.y( );
	if ( xmouse>=0 && ymouse>=0 )  emit changePos ( );
}

//
// This method puts the initial coordinates each time window is resized
//
void Cubo::resizeEvent( QResizeEvent * )
{
  w = width( );
	h = height( );

	xini = w/2;
	yini = h/2;

	emit changeSize ( );
}

QSizePolicy Cubo::sizePolicy() const
{
	return QSizePolicy( QSizePolicy::Expanding, QSizePolicy::Expanding );
}

// JFA:
// Intercambia dos puntos, de modo que el origen siempre est
// del lado derecho ( x2 - x1 > 0 )
//
void Cubo::SwapPoints( int &x1, int &y1, int &x2, int &y2)
{
  int tempo = x1;
  x1 = x2;
  x2 = tempo;
  tempo = y1;
  y1 = y2;
  y2 = tempo;
}

// JFA:
// Prueba el algortmo MIDPOINT
// Resuelve tres casos especiales:
//      a) si x2 - x1 = 0, entonces m es infinita (lnea vertical)
//      b) si y2 - y1 = 0, entonces m es cero (lnea horizontal)
//      c) si dy/dx = 1, entonces m es 1 (lnea diagonal) o bien
//         si dy/dx = -1, entonces m = -1 (diagonal)
//
// El problema se resuelve para un octante: (0 < m < 1) y entonces
// cualquier otro caso se transforma a este octante, se resuelve y
// se mapea nuevamente al octante destino.
//
void Cubo::LineMidpoint ( int x1, int y1, int x2, int y2, QColor color)
{
  int x, y;

  xact_d = (double)x2;
  xact = x2;
  yact_d = (double)y2;
  yact = y2;

  // Trata casos especiales:
  // Si pluma arriba, no hay nada que dibujar, solo actualiza
  // Pact(xact, yact)
  if ( !penst ) {   // pen is up
    return;
  }

  // Si no hay cambio, simplemente regresa...
  if (x1 == x2 && y1 == y2) {
    QPainter paint( this );
    paint.setPen(color);
    paint.drawPoint(Tx(x2), Ty(y2));
  	return;
  }
  	
  // si P2 est a la izquierda de P1, entonces intercambia
  // los puntos:
  if ( (x2 - x1) < 0 )
    SwapPoints(x1, y1, x2, y2);

  // si dy = 0, m es 0 y se trata de una lnea horizontal
  int dy = y2 - y1;
  if ( !dy ) {
    DrawHorizontal(x1, y1, x2, y2, color);
    return;
  }

  // si dx = 0, m es infinita y es una lnea vertical
  int dx = x2 - x1;
  if ( !dx ) {
    DrawVertical(x1, y1, x2, y2, color);
    return;
  }

  // si |dx| == |dy|, entonces es una diagonal con m = 1 o m = -1
  if ( abs(dx) == abs(dy) ) {
    DrawDiagonal(x1, y1, x2, y2, color);
    return;
  }

  double m = (double)dy/(double)dx;        // definiremos el cuadrante
                                           // mediante la pendiente
  // Si 0 < m < 1, estamos en el primer o quinto octante, 
  // no se requiere transformacin...
  int caso = 1;

  // Si 1 < m < infinito, intercambia x1 con y1 y x2 con y2:
  if ( (m > 1.0 && m < MAXDOUBLE) ) { // octante 2 o 6
    caso = 2;

    // intercambia componentes x con componentes y
    IntSwap(x1, y1);
    IntSwap(x2, y2);
    if ( x2 < x1 )
      SwapPoints(x1, y1, x2, y2);
  }
  else if ( (m < -1 && m > -MAXDOUBLE) ) { // octante 3 o 7
    caso = 3;

    // intercambia componentes x con componentes y
    IntSwap(x1, y1);
    IntSwap(x2, y2);

    // al pasar al cuadrante 1, los puntos quedan en orden incorrecto
    if (x2 < x1)
      SwapPoints(x1, y1, x2, y2);
    y1 = -y1;
    y2 = -y2;
  }
  else if ( m < 0 && m > -1 ) { // octante 4 u 8
    caso = 4;
    x1 = -x1;
    x2 = -x2;
    SwapPoints(x1, y1, x2, y2);
  }
    
  dy = y2 - y1;
  dx = x2 - x1;
  int d  = (dy << 1) - dx;
  int incrE  = dy << 1;
  int incrNE = (dy - dx) << 1;
  y = y1;
  x = x1;

  QPainter paint( this );
  paint.setPen(color);
  switch (caso) {   // mapea al cuadrante adecuado...
  case 1:
    paint.drawPoint(Tx(x), Ty(y));
    break;
  case 2:
    paint.drawPoint(Tx(y), Ty(x));
    break;
  case 3:
    paint.drawPoint(Tx(-y), Ty(x));
    break;
  case 4:
    paint.drawPoint(Tx(-x), Ty(y));
    break;
  }
  while (x < x2) {
    x++;
    if (d <= 0)
      d += incrE;
    else {
      y++;
      d += incrNE;
    }
    // mapea el punto a las coordenadas cartesianas adecuadas...
    switch (caso) {
    case 1:
      paint.drawPoint(Tx(x), Ty(y));
      break;
    case 2:
      paint.drawPoint(Tx(y), Ty(x));
      break;
    case 3:
      paint.drawPoint(Tx(-y), Ty(x));
      break;
    case 4:
      paint.drawPoint(Tx(-x), Ty(y));
      break;
    }
  }
}

// JFA:
// Trata el caso especial de una diagonal: m = dy/dx = 1 o -1
//
void Cubo::DrawDiagonal(int x1, int y1, int x2, int y2, QColor color) {
  int x = x1;
  int y = y1;
  int dx = x2 - x1;
  int dy = y2 - y1;

  QPainter paint( this );
  paint.setPen(color);
  // mapea el punto a las coordenadas cartesianas...
  paint.drawPoint(Tx(x), Ty(y));

  if ( (dy/dx) == -1)   // entonces la pendiente es negativa
    while (x != x2) {
      x++;
      y--;
      paint.drawPoint(Tx(x), Ty(y));
    }
  else
    while (x != x2) {
      x++;
      y++;
      paint.drawPoint(Tx(x), Ty(y));
    }
}
  
// JFA:
// Trata el caso especial de una vertical: m = dy/dx = infinito
//
void Cubo::DrawVertical(int x1, int y1, int x2, int y2, QColor color) {
  if (y1 > y2) {
    int tempo = y1;
    y1 = y2;
    y2 = tempo;
  }
  int y = y1;
  int x = Tx(x1);

  QPainter paint( this );
  paint.setPen(color);

  // mapea el punto a las coordenadas cartesianas...
  paint.drawPoint(x, Ty(y));
  while (y < y2) {
    y++;
    paint.drawPoint(x, Ty(y));
  }
}
  
// JFA:
// Trata el caso especial de una horizontal: m = dy/dx = 0
//
void Cubo::DrawHorizontal(int x1, int y1, int x2, int y2, QColor color) {
  int y = Ty(y1);
  int x = x1;

  QPainter paint( this );
  paint.setPen(color);

  // mapea el punto a las coordenadas cartesianas...
  paint.drawPoint(Tx(x), y);
  while (x < x2) {
    x++;
    paint.drawPoint(Tx(x), y);
  }
}

/*
  JFA
  Intercambia dos enteros.
*/
void Cubo::IntSwap(int &e1, int &e2) {
  int tempo = e1;
  e1 = e2;
  e2 = tempo;
}

/*
  JFA
  Avanza la tortuga una distancia 'dist' a partir de la posicin
  actual 'xact, yact' y en el ngulo 'ang' actual
*/
void Cubo::Forward(double dist) {
  double x2, y2;

    y2 = yact_d + dist * sin(ang * M_PI/180.0);
    x2 = xact_d + dist * cos(ang * M_PI/180.0);

  LineMidpoint(int(xact_d), int (yact_d), int (x2), int (y2), pen_color);
  xact_d = x2;
  yact_d = y2;
}

/*
  JFA
  Retrocede la tortuga una distancia 'dist' a partir de la posicin
  actual 'xact, yact' y en el ngulo 'ang' actual
*/
void Cubo::Back(double dist) {
  double x2, y2;
  double c_ang = ang+180.0;

  if (c_ang > 360.0)
  	c_ang -= 360.0;

  y2 = yact_d + dist * sin( c_ang * M_PI/180.0);
  x2 = xact_d + dist * cos( c_ang * M_PI/180.0);

  LineMidpoint(int (xact_d), int (yact_d), int (x2), int (y2), pen_color);
  xact_d = x2;
  yact_d = y2;
}

// Here we must to include our program :

void Cubo::paintEvent( QPaintEvent * )
{
	QPointArray p(16);

	for (int a=0; a<4; a++)
		p[a] = QPoint(ipuntos3D[a].x, ipuntos3D[a].y);
 	p[4] = p[0];
	for (int a=5; a<9; a++)
		p[a] = QPoint(ipuntos3D[a-1].x, ipuntos3D[a-1].y);
 	p[9] = p[5];

 	p[10] = p[6];
 	p[11] = p[1];
 	p[12] = p[2];
 	p[13] = p[7];
 	p[14] = p[8];
 	p[15] = p[3];
	
	// ajusta coordenadas a las de la tortuga...
	for (int a=0; a<16; a++) {
		p[a].rx() = Tx(p[a].rx());
		p[a].ry() = Ty(p[a].ry());
	}

	QPainter paint( this );                     // painter object
  	// paint.setWindow( 0, 0, 2*xini, 2*yini );    // define coordinate system
	// paint.setBrush(darkBlue);
	paint.setPen(darkBlue);
	// pen.setStyle(SolidLine);  // este es el estilo base...
	// pen.setWidth(1);
	paint.drawPolyline(p);		

	//paint.setBrush(red);
	paint.setPen(red);
	paint.drawLine(Tx(ipuntos3D[8].x), Ty(ipuntos3D[8].y),
	               Tx(ipuntos3D[9].x), Ty(ipuntos3D[9].y) );
}


//
// JFA:
//			Aplica la matriz de transformacin Matrix3D al punto
//			sealado por int indice.
void Cubo::aplicaT3D(int indice) {
	double res[3] = {0.0, 0.0, 0.0};
	double punto[4] = { fpuntos3D[indice].fx,
	                    fpuntos3D[indice].fy,
	                    fpuntos3D[indice].fz,
	                    1.0 };
	// JFA: como P'(i) = Sum Matrix(i,j)*P(j)
	for (int i=0; i<3; i++)
		for (int j=0; j<4; j++)
			res[i] += Matrix3D[i][j] * punto[j];
	fpuntos3D[indice].fx = res[0];
	fpuntos3D[indice].fy = res[1];
	fpuntos3D[indice].fz = res[2];
}


//
// JFA:
//			Aplica la transformacin para cambiar la escala
//			del conjunto de puntos definido por fpuntos3D[] y
//			pasa las nuevas coordenadas al arreglo ipuntos3D[]
//			redondeando mediante Round() --ver #define Round()
//			al inicio de este archivo.
//			Si el argumento es positivo, el tamao se incrementa,
//  		si es negativo, se decrementa.
void Cubo::cambiaEscala3D(double factor) {
	double fact;
	if (factor < 0)
		fact = 1.0/(-factor);
	else
		fact = double(factor);
		
	// JFA: creamos la matriz de transformacin...	
	//			|	Sx   0   0  0|
	//			|	 0  Sy   0  0|   Sx = Sy = Sz = fact
	//			|	 0   0  Sz  0|
	//      |  0   0   0  1|
	for (int i=0; i<4; i++)
		for (int j=0; j<4; j++) {
			if (i == j)
  			Matrix3D[i][j] = fact;
  		else
  			Matrix3D[i][j] = 0.0;
		}
	Matrix3D[3][3] = 1.0;
	
	// JFA: Aplica la transformacin a todos y cada uno de los
	//      puntos fpuntos3D[] y coloca el resultado redondeado
	//      en ipuntos3D[]
	for (int i=0; i<Npuntos; i++)  aplicaT3D(i);
}

//
// JFA:
//			Aplica la transformacin para rotar el objeto
//			que define el conjunto de puntos fpuntos3D[]
//			Los nuevos puntos resultantes, se guardan
//			en ipuntos3D[] redondeando mediante Round():
//      ver #define Round() al inicio de este archivo.
//			El eje de rotacin, es el punto fpunto3D[0] del objeto
//
void Cubo::cambiaRota3D( float myangle, char eje) {
	double fact = myangle*M_PI/180.0;
	double Seno = sin(fact);
	double Cose = cos(fact);
	
	int a, b;                 // indices de ajuste....
		
	// JFA: crea matriz identidad....
	for (int i=0; i<4; i++)
		for (int j=0; j<4; j++) {
			if (i == j) Matrix3D[i][j] = 1.0;
  			else Matrix3D[i][j] = 0.0;
		}
	
	// JFA: variacin para rotar sobre X
	//			|	  1     0        0      0|
	//			|	  0   cos(a)  -sen(a)   0|   a = fact
	//			|	  0   sen(a)   cos(a)   0|
	//  		|     0     0        0      1|
	if (eje == 'x') {             // rota sobre X...
	  a = 1;	b = 2;
 	}
	// JFA: variacin para rotar sobre Y
	//			|	 cos(a)    0   sen(a)  0|
	//			|	   0       1     0     0|   a = fact
	//			|	-sen(a)    0   cos(a)  0|
	//  		|      0       0     0     1|
	else if (eje == 'y') {				// rota sobre Y...
	  a = 2;    b = 0;
	}
	// JFA: variacin para rotar sobre Z
	//			|	cos(a)  -sen(a)  0   0|
	//			|	sen(a)   cos(a)  0   0|   a = fact
	//			|     0        0     1   0|
	//			|     0        0     0   1|
	else if (eje == 'z') {				// rota sobre Z...
	  a = 0;    b = 1;
	}
	else {					
		cerr << "Error en cdigo fuente\n";
		cerr << "Se cierra el progrma\n";
		exit(1);
	}
	// JFA: crea la matriz de transformacin...
	Matrix3D[a][a] = Matrix3D[b][b] = Cose;
	Matrix3D[b][a] =  Seno;
	Matrix3D[a][b] = -Seno;
	
	// JFA: Aplica la transformacin a todos y cada uno de los
	//      puntos fpuntos3D[] y coloca el resultado redondeado en
	//      ipuntos3D[]
	for (int i=0; i<Npuntos; i++) aplicaT3D(i);
}

void Cubo::puntos(void) {
    // Los 8 puntos puntos para dibujar un cubo unitario
	// por medio de lneas
	// Primero una cuadrado de base en el plano x-z
	fpuntos3D[ 0].fx = 0.0; fpuntos3D[ 0].fy = 0.0; fpuntos3D[ 0].fz = 0.0;
	fpuntos3D[ 1].fx = 1.0;	fpuntos3D[ 1].fy = 0.0;	fpuntos3D[ 1].fz = 0.0;
	fpuntos3D[ 2].fx = 1.0;	fpuntos3D[ 2].fy = 0.0;	fpuntos3D[ 2].fz = 1.0;
	fpuntos3D[ 3].fx = 0.0;	fpuntos3D[ 3].fy = 0.0;	fpuntos3D[ 3].fz = 1.0;
	// el otro cuadro en y=1
	fpuntos3D[ 4].fx = 0.0;	fpuntos3D[ 4].fy = 1.0;	fpuntos3D[ 4].fz = 0.0;
	fpuntos3D[ 5].fx = 1.0; fpuntos3D[ 5].fy = 1.0; fpuntos3D[ 5].fz = 0.0;
	fpuntos3D[ 6].fx = 1.0;	fpuntos3D[ 6].fy = 1.0;	fpuntos3D[ 6].fz = 1.0;
	fpuntos3D[ 7].fx = 0.0;	fpuntos3D[ 7].fy = 1.0;	fpuntos3D[ 7].fz = 1.0;

	// Y estos dos puntos marcan la "gran diagonal" de (0,0,0) a (1,1,1)
	// pero un poco ms grande :-)
	fpuntos3D[ 8].fx =-0.1;	fpuntos3D[ 8].fy =-0.1;	fpuntos3D[ 8].fz =-0.1;
	fpuntos3D[ 9].fx = 1.1;	fpuntos3D[ 9].fy = 1.1;	fpuntos3D[ 9].fz = 1.1;

	Npuntos = 10;
}
